package com.fr.plugin.third.party.jsdjjed;

import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.plugin.context.PluginContext;
import com.fr.plugin.observer.inner.AbstractPluginLifecycleMonitor;
import com.fr.plugin.third.party.jsdjjed.config.AppDataConfig;
import com.fr.plugin.third.party.jsdjjed.handle.ImageOutputFormat;
import com.fr.plugin.third.party.jsdjjed.schedule.AppMessagePushHandler;
import com.fr.plugin.third.party.jsdjjed.schedule.bean.OutputAppMessagePush;
import com.fr.plugin.third.party.jsdjjed.schedule.entity.AppMessagePushEntity;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.schedule.extension.report.job.output.BaseOutputFormat;
import com.fr.schedule.feature.ScheduleOutputActionEntityRegister;
import com.fr.schedule.feature.output.OutputActionHandler;
import com.fr.stable.fun.Authorize;



/**
 * 配置信息初始化
 */
@EnableMetrics
public class OutputPluginLifecycleMonitor extends AbstractPluginLifecycleMonitor {
    @Override
    @Focus(id = "com.fr.plugin.third.party.jsdjjed", text = "plugin-jsdjjed", source = Original.PLUGIN)
    public void afterRun(PluginContext pluginContext) {
        BaseOutputFormat.registerOutputFormat(new ImageOutputFormat());
        AppDataConfig.getInstance();
        OutputActionHandler.registerHandler(new AppMessagePushHandler(), OutputAppMessagePush.class.getName());
        ScheduleOutputActionEntityRegister.getInstance().addClass(AppMessagePushEntity.class);

    }

    @Override
    public void beforeStop(PluginContext pluginContext) {
        BaseOutputFormat.removeOutputFormat(ImageOutputFormat.FORMAT_IMAGE);
        OutputActionHandler.removeOutputHandler(OutputAppMessagePush.class.getName());
        ScheduleOutputActionEntityRegister.getInstance().removeClass(AppMessagePushEntity.class);
    }
}
