package com.fr.plugin.third.party.jsdjjed.app.config;

import com.fr.db.fun.impl.AbstractDBAccessProvider;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.fun.Authorize;


@Authorize(callSignKey = "com.fr.plugin.third.party.jsdjjed")
public class AppConfigAccessBridge extends AbstractDBAccessProvider {

    private static DBAccessor dbAccessor = null;

    public static DBAccessor getDbAccessor() {
        return dbAccessor;
    }

    @Override
    public DAOProvider[] registerDAO() {
        return new DAOProvider[]{
                new DAOProvider() {
                    @Override
                    public Class getEntityClass() {
                        return AppConfigEntity.class;
                    }

                    @Override
                    public Class<? extends BaseDAO> getDAOClass() {
                        return AppConfigDao.class;
                    }
                }
        };
    }

    @Override
    public void onDBAvailable(DBAccessor dbAccessor) {
        AppConfigAccessBridge.dbAccessor = dbAccessor;
    }
}
