package com.fr.plugin.third.party.jsdjjed.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;

import java.util.HashMap;
import java.util.Map;


public class AppDataConfig extends DefaultConfiguration {
    public String getNameSpace() {
        return this.getClass().getName();
    }

    private static volatile AppDataConfig config = null;

    public static AppDataConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(AppDataConfig.class);
        }
        return config;
    }


    private static volatile Map<String, String> URL_MAP = new HashMap<>();

    public synchronized static void addMapUrl(String key, String url) {
        URL_MAP.put(key, url);
    }

    public synchronized static String getMapUrl(String key) {
        if (!URL_MAP.containsKey(key)) {
            return "";
        }
        String url = URL_MAP.get(key);
        URL_MAP.remove(key);
        return url;
    }

    private Conf<String> frUrl = Holders.simple("");
    private Conf<String> accessTokenUrl = Holders.simple("https://xxx/open-apis/auth/v3/app_access_token/internal");
    private Conf<String> codeUserUrl = Holders.simple("https://xxx/open-apis/authen/v1/access_token");
    private Conf<String> chatGroupsUrl = Holders.simple("https://xxx/open-apis/im/v1/chats");
    private Conf<String> usersUrl = Holders.simple("https://xxx/open-apis/user/v1/batch_get_id");
    private Conf<String> sendMessageUrl = Holders.simple("https://xxx/open-apis/im/v1/messages");
    private Conf<String> sendBatchMessageUrl = Holders.simple("https://xxx/open-apis/message/v4/batch_send");
    private Conf<String> uploadImageUrl = Holders.simple("https://xxx/open-apis/im/v1/images");
    private Conf<String> uploadFileUrl = Holders.simple("https://xxx/open-apis/im/v1/files");
    private Conf<String> authorizeUrl = Holders.simple("https://xxx/open-apis/authen/v1/index");

    private Conf<Boolean> accessTokenUrlEscbOption = Holders.simple(true);
    private Conf<Boolean> codeUserUrlEscbOption = Holders.simple(true);
    private Conf<Boolean> chatGroupsUrlEscbOption = Holders.simple(true);
    private Conf<Boolean> usersUrlEscbOption = Holders.simple(true);
    private Conf<Boolean> sendMessageUrlEscbOption = Holders.simple(true);
    private Conf<Boolean> sendBatchMessageUrlEscbOption = Holders.simple(true);
    private Conf<Boolean> uploadImageUrlEscbOption = Holders.simple(false);
    private Conf<Boolean> uploadFileUrlEscbOption = Holders.simple(false);
    private Conf<Boolean> authorizeUrlEscbOption = Holders.simple(false);

    private Conf<String> accessTokenUrlEscbCode = Holders.simple("xxx.app.app_access_token");
    private Conf<String> codeUserUrlEscbCode = Holders.simple("xxx.app.get_user_accessToken");
    private Conf<String> chatGroupsUrlEscbCode = Holders.simple("xxx.app.get_chat_v4_list");
    private Conf<String> usersUrlEscbCode = Holders.simple("xxx.app.lark_batch_get_id");
    private Conf<String> sendMessageUrlEscbCode = Holders.simple("xxx.app.feishu_send_message");
    private Conf<String> sendBatchMessageUrlEscbCode = Holders.simple("xxx.app.feishu_batch_send");
    private Conf<String> uploadImageUrlEscbCode = Holders.simple("");
    private Conf<String> uploadFileUrlEscbCode = Holders.simple("");
    private Conf<String> authorizeUrlEscbCode = Holders.simple("");

    private Conf<String> accessTokenUrlEscbVersion  = Holders.simple("1.0");
    private Conf<String> codeUserUrlEscbVersion = Holders.simple("1.0");
    private Conf<String> chatGroupsUrlEscbVersion = Holders.simple("1.0");
    private Conf<String> usersUrlEscbVersion  = Holders.simple("1.0");
    private Conf<String> sendMessageUrlEscbVersion  = Holders.simple("2.0");
    private Conf<String> sendBatchMessageUrlEscbVersion = Holders.simple("1.0");
    private Conf<String> uploadImageUrlEscbVersion = Holders.simple("");
    private Conf<String> uploadFileUrlEscbVersion = Holders.simple("");
    private Conf<String> authorizeUrlEscbVersion  = Holders.simple("");

    private Conf<String> escbUrl  = Holders.simple("http://xxxxxx/ecsb/gw/cls/rf");
    private Conf<String> escbAppCode = Holders.simple("xx");
    private Conf<String> escbAppToken = Holders.simple("xxx");
    private Conf<String> escbOrgCode = Holders.simple("xxx");
    private Conf<String> escbSysCode  = Holders.simple("xxx");



    @Identifier(value = "loginTypeNameParameter", name = "登录类型参数名称", description = "", status = Status.HIDE)
    private Conf<String> loginTypeNameParameter = Holders.simple("loginType");

    @Identifier(value = "loginTypeValue", name = "登录类型值", description = "", status = Status.HIDE)
    private Conf<String> loginTypeValue = Holders.simple("oauth");

    public String getLoginTypeNameParameter() {
        return loginTypeNameParameter.get();
    }

    public void setLoginTypeNameParameter(String loginTypeNameParameter) {
        this.loginTypeNameParameter.set(loginTypeNameParameter);
    }

    public String getLoginTypeValue() {
        return loginTypeValue.get();
    }

    public void setLoginTypeValue(String loginTypeValue) {
        this.loginTypeValue.set(loginTypeValue);
    }

    public String getFrUrl() {
        return frUrl.get();
    }

    public void setFrUrl(String frUrl) {
        this.frUrl.set(frUrl);
    }

    public String getAccessTokenUrl() {
        return accessTokenUrl.get();
    }

    public void setAccessTokenUrl(String accessTokenUrl) {
        this.accessTokenUrl.set(accessTokenUrl);
    }

    public String getCodeUserUrl() {
        return codeUserUrl.get();
    }

    public void setCodeUserUrl(String codeUserUrl) {
        this.codeUserUrl.set(codeUserUrl);
    }

    public String getChatGroupsUrl() {
        return chatGroupsUrl.get();
    }

    public void setChatGroupsUrl(String chatGroupsUrl) {
        this.chatGroupsUrl.set(chatGroupsUrl);
    }

    public String getUsersUrl() {
        return usersUrl.get();
    }

    public void setUsersUrl(String usersUrl) {
        this.usersUrl.set(usersUrl);
    }

    public String getSendMessageUrl() {
        return sendMessageUrl.get();
    }

    public void setSendMessageUrl(String sendMessageUrl) {
        this.sendMessageUrl.set(sendMessageUrl);
    }

    public String getSendBatchMessageUrl() {
        return sendBatchMessageUrl.get();
    }

    public void setSendBatchMessageUrl(String sendBatchMessageUrl) {
        this.sendBatchMessageUrl.set(sendBatchMessageUrl);
    }

    public String getUploadImageUrl() {
        return uploadImageUrl.get();
    }

    public void setUploadImageUrl(String uploadImageUrl) {
        this.uploadImageUrl.set(uploadImageUrl);
    }

    public String getUploadFileUrl() {
        return uploadFileUrl.get();
    }

    public void setUploadFileUrl(String uploadFileUrl) {
        this.uploadFileUrl.set(uploadFileUrl);
    }

    public String getAuthorizeUrl() {
        return authorizeUrl.get();
    }

    public void setAuthorizeUrl(String authorizeUrl) {
        this.authorizeUrl.set(authorizeUrl);
    }

    public Boolean isAccessTokenUrlEscbOption() {
        return accessTokenUrlEscbOption.get();
    }

    public void setAccessTokenUrlEscbOption(Boolean accessTokenUrlEscbOption) {
        this.accessTokenUrlEscbOption.set(accessTokenUrlEscbOption);
    }

    public Boolean isCodeUserUrlEscbOption() {
        return codeUserUrlEscbOption.get();
    }

    public void setCodeUserUrlEscbOption(Boolean codeUserUrlEscbOption) {
        this.codeUserUrlEscbOption.set(codeUserUrlEscbOption);
    }

    public Boolean isChatGroupsUrlEscbOption() {
        return chatGroupsUrlEscbOption.get();
    }

    public void setChatGroupsUrlEscbOption(Boolean chatGroupsUrlEscbOption) {
        this.chatGroupsUrlEscbOption.set(chatGroupsUrlEscbOption);
    }

    public Boolean isUsersUrlEscbOption() {
        return usersUrlEscbOption.get();
    }

    public void setUsersUrlEscbOption(Boolean usersUrlEscbOption) {
        this.usersUrlEscbOption.set(usersUrlEscbOption);
    }

    public Boolean isSendMessageUrlEscbOption() {
        return sendMessageUrlEscbOption.get();
    }

    public void setSendMessageUrlEscbOption(Boolean sendMessageUrlEscbOption) {
        this.sendMessageUrlEscbOption.set(sendMessageUrlEscbOption);
    }

    public Boolean isSendBatchMessageUrlEscbOption() {
        return sendBatchMessageUrlEscbOption.get();
    }

    public void setSendBatchMessageUrlEscbOption(Boolean sendBatchMessageUrlEscbOption) {
        this.sendBatchMessageUrlEscbOption.set(sendBatchMessageUrlEscbOption);
    }

    public Boolean isUploadImageUrlEscbOption() {
        return uploadImageUrlEscbOption.get();
    }

    public void setUploadImageUrlEscbOption(Boolean uploadImageUrlEscbOption) {
        this.uploadImageUrlEscbOption.set(uploadImageUrlEscbOption);
    }

    public Boolean isUploadFileUrlEscbOption() {
        return uploadFileUrlEscbOption.get();
    }

    public void setUploadFileUrlEscbOption(Boolean uploadFileUrlEscbOption) {
        this.uploadFileUrlEscbOption.set(uploadFileUrlEscbOption);
    }

    public Boolean isAuthorizeUrlEscbOption() {
        return authorizeUrlEscbOption.get();
    }

    public void setAuthorizeUrlEscbOption(Boolean authorizeUrlEscbOption) {
        this.authorizeUrlEscbOption.set(authorizeUrlEscbOption);
    }

    public String getAccessTokenUrlEscbCode() {
        return accessTokenUrlEscbCode.get();
    }

    public void setAccessTokenUrlEscbCode(String accessTokenUrlEscbCode) {
        this.accessTokenUrlEscbCode.set(accessTokenUrlEscbCode);
    }

    public String getCodeUserUrlEscbCode() {
        return codeUserUrlEscbCode.get();
    }

    public void setCodeUserUrlEscbCode(String codeUserUrlEscbCode) {
        this.codeUserUrlEscbCode.set(codeUserUrlEscbCode);
    }

    public String getChatGroupsUrlEscbCode() {
        return chatGroupsUrlEscbCode.get();
    }

    public void setChatGroupsUrlEscbCode(String chatGroupsUrlEscbCode) {
        this.chatGroupsUrlEscbCode.set(chatGroupsUrlEscbCode);
    }

    public String getUsersUrlEscbCode() {
        return usersUrlEscbCode.get();
    }

    public void setUsersUrlEscbCode(String usersUrlEscbCode) {
        this.usersUrlEscbCode.set(usersUrlEscbCode);
    }

    public String getSendMessageUrlEscbCode() {
        return sendMessageUrlEscbCode.get();
    }

    public void setSendMessageUrlEscbCode(String sendMessageUrlEscbCode) {
        this.sendMessageUrlEscbCode.set(sendMessageUrlEscbCode);
    }

    public String getSendBatchMessageUrlEscbCode() {
        return sendBatchMessageUrlEscbCode.get();
    }

    public void setSendBatchMessageUrlEscbCode(String sendBatchMessageUrlEscbCode) {
        this.sendBatchMessageUrlEscbCode.set(sendBatchMessageUrlEscbCode);
    }

    public String getUploadImageUrlEscbCode() {
        return uploadImageUrlEscbCode.get();
    }

    public void setUploadImageUrlEscbCode(String uploadImageUrlEscbCode) {
        this.uploadImageUrlEscbCode.set(uploadImageUrlEscbCode);
    }

    public String getUploadFileUrlEscbCode() {
        return uploadFileUrlEscbCode.get();
    }

    public void setUploadFileUrlEscbCode(String uploadFileUrlEscbCode) {
        this.uploadFileUrlEscbCode.set(uploadFileUrlEscbCode);
    }

    public String getAuthorizeUrlEscbCode() {
        return authorizeUrlEscbCode.get();
    }

    public void setAuthorizeUrlEscbCode(String authorizeUrlEscbCode) {
        this.authorizeUrlEscbCode.set(authorizeUrlEscbCode);
    }

    public String getAccessTokenUrlEscbVersion() {
        return accessTokenUrlEscbVersion.get();
    }

    public void setAccessTokenUrlEscbVersion(String accessTokenUrlEscbVersion) {
        this.accessTokenUrlEscbVersion.set(accessTokenUrlEscbVersion);
    }

    public String getCodeUserUrlEscbVersion() {
        return codeUserUrlEscbVersion.get();
    }

    public void setCodeUserUrlEscbVersion(String codeUserUrlEscbVersion) {
        this.codeUserUrlEscbVersion.set(codeUserUrlEscbVersion);
    }

    public String getChatGroupsUrlEscbVersion() {
        return chatGroupsUrlEscbVersion.get();
    }

    public void setChatGroupsUrlEscbVersion(String chatGroupsUrlEscbVersion) {
        this.chatGroupsUrlEscbVersion.set(chatGroupsUrlEscbVersion);
    }

    public String getUsersUrlEscbVersion() {
        return usersUrlEscbVersion.get();
    }

    public void setUsersUrlEscbVersion(String usersUrlEscbVersion) {
        this.usersUrlEscbVersion.set(usersUrlEscbVersion);
    }

    public String getSendMessageUrlEscbVersion() {
        return sendMessageUrlEscbVersion.get();
    }

    public void setSendMessageUrlEscbVersion(String sendMessageUrlEscbVersion) {
        this.sendMessageUrlEscbVersion.set(sendMessageUrlEscbVersion);
    }

    public String getSendBatchMessageUrlEscbVersion() {
        return sendBatchMessageUrlEscbVersion.get();
    }

    public void setSendBatchMessageUrlEscbVersion(String sendBatchMessageUrlEscbVersion) {
        this.sendBatchMessageUrlEscbVersion.set(sendBatchMessageUrlEscbVersion);
    }

    public String getUploadImageUrlEscbVersion() {
        return uploadImageUrlEscbVersion.get();
    }

    public void setUploadImageUrlEscbVersion(String uploadImageUrlEscbVersion) {
        this.uploadImageUrlEscbVersion.set(uploadImageUrlEscbVersion);
    }

    public String getUploadFileUrlEscbVersion() {
        return uploadFileUrlEscbVersion.get();
    }

    public void setUploadFileUrlEscbVersion(String uploadFileUrlEscbVersion) {
        this.uploadFileUrlEscbVersion.set(uploadFileUrlEscbVersion);
    }

    public String getAuthorizeUrlEscbVersion() {
        return authorizeUrlEscbVersion.get();
    }

    public void setAuthorizeUrlEscbVersion(String authorizeUrlEscbVersion) {
        this.authorizeUrlEscbVersion.set(authorizeUrlEscbVersion);
    }

    public String getEscbUrl() {
        return escbUrl.get();
    }

    public void setEscbUrl(String escbUrl) {
        this.escbUrl.set(escbUrl);
    }

    public String getEscbAppCode() {
        return escbAppCode.get();
    }

    public void setEscbAppCode(String escbAppCode) {
        this.escbAppCode.set(escbAppCode);
    }

    public String getEscbAppToken() {
        return escbAppToken.get();
    }

    public void setEscbAppToken(String escbAppToken) {
        this.escbAppToken.set(escbAppToken);
    }

    public String getEscbOrgCode() {
        return escbOrgCode.get();
    }

    public void setEscbOrgCode(String escbOrgCode) {
        this.escbOrgCode.set(escbOrgCode);
    }

    public String getEscbSysCode() {
        return escbSysCode.get();
    }

    public void setEscbSysCode(String escbSysCode) {
        this.escbSysCode.set(escbSysCode);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        AppDataConfig cloned = (AppDataConfig) super.clone();
        cloned.loginTypeNameParameter = (Conf<String>) loginTypeNameParameter.clone();
        cloned.loginTypeValue = (Conf<String>) loginTypeValue.clone();
        cloned.accessTokenUrl = (Conf<String>) accessTokenUrl.clone();
        cloned.frUrl = (Conf<String>) frUrl.clone();
        cloned.codeUserUrl = (Conf<String>) codeUserUrl.clone();
        cloned.chatGroupsUrl = (Conf<String>) chatGroupsUrl.clone();
        cloned.sendMessageUrl = (Conf<String>) sendMessageUrl.clone();
        cloned.uploadImageUrl = (Conf<String>) uploadImageUrl.clone();
        cloned.uploadFileUrl = (Conf<String>) uploadFileUrl.clone();
        cloned.usersUrl = (Conf<String>) usersUrl.clone();
        cloned.sendBatchMessageUrl = (Conf<String>) sendBatchMessageUrl.clone();
        cloned.authorizeUrl = (Conf<String>) authorizeUrl.clone();

        cloned.accessTokenUrlEscbOption = (Conf<Boolean>) accessTokenUrlEscbOption.clone();
        cloned.codeUserUrlEscbOption = (Conf<Boolean>) codeUserUrlEscbOption.clone();
        cloned.chatGroupsUrlEscbOption = (Conf<Boolean>) chatGroupsUrlEscbOption.clone();
        cloned.usersUrlEscbOption = (Conf<Boolean>) usersUrlEscbOption.clone();
        cloned.sendMessageUrlEscbOption = (Conf<Boolean>) sendMessageUrlEscbOption.clone();
        cloned.sendBatchMessageUrlEscbOption = (Conf<Boolean>) sendBatchMessageUrlEscbOption.clone();
        cloned.uploadImageUrlEscbOption = (Conf<Boolean>) uploadImageUrlEscbOption.clone();
        cloned.uploadFileUrlEscbOption = (Conf<Boolean>) uploadFileUrlEscbOption.clone();
        cloned.authorizeUrlEscbOption = (Conf<Boolean>) authorizeUrlEscbOption.clone();
        cloned.accessTokenUrlEscbCode = (Conf<String>) accessTokenUrlEscbCode.clone();
        cloned.codeUserUrlEscbCode = (Conf<String>) codeUserUrlEscbCode.clone();
        cloned.chatGroupsUrlEscbCode = (Conf<String>) chatGroupsUrlEscbCode.clone();
        cloned.usersUrlEscbCode = (Conf<String>) usersUrlEscbCode.clone();
        cloned.sendMessageUrlEscbCode = (Conf<String>) sendMessageUrlEscbCode.clone();
        cloned.sendBatchMessageUrlEscbCode = (Conf<String>) sendBatchMessageUrlEscbCode.clone();
        cloned.uploadImageUrlEscbCode = (Conf<String>) uploadImageUrlEscbCode.clone();
        cloned.uploadFileUrlEscbCode = (Conf<String>) uploadFileUrlEscbCode.clone();
        cloned.authorizeUrlEscbCode = (Conf<String>) authorizeUrlEscbCode.clone();
        cloned.accessTokenUrlEscbVersion = (Conf<String>) accessTokenUrlEscbVersion.clone();
        cloned.codeUserUrlEscbVersion = (Conf<String>) codeUserUrlEscbVersion.clone();
        cloned.chatGroupsUrlEscbVersion = (Conf<String>) chatGroupsUrlEscbVersion.clone();
        cloned.usersUrlEscbVersion = (Conf<String>) usersUrlEscbVersion.clone();
        cloned.sendMessageUrlEscbVersion = (Conf<String>) sendMessageUrlEscbVersion.clone();
        cloned.sendBatchMessageUrlEscbVersion = (Conf<String>) sendBatchMessageUrlEscbVersion.clone();
        cloned.uploadImageUrlEscbVersion = (Conf<String>) uploadImageUrlEscbVersion.clone();
        cloned.uploadFileUrlEscbVersion = (Conf<String>) uploadFileUrlEscbVersion.clone();
        cloned.authorizeUrlEscbVersion = (Conf<String>) authorizeUrlEscbVersion.clone();
        cloned.escbUrl = (Conf<String>) escbUrl.clone();
        cloned.escbAppCode = (Conf<String>) escbAppCode.clone();
        cloned.escbAppToken = (Conf<String>) escbAppToken.clone();
        cloned.escbOrgCode = (Conf<String>) escbOrgCode.clone();
        cloned.escbSysCode = (Conf<String>) escbSysCode.clone();
        return cloned;
    }
}
