package com.fr.plugin.third.party.jsdjjed.http.app;

import com.fanruan.api.util.StringKit;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.general.IOUtils;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.third.party.jsdjjed.Utils;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigData;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 */
public class DeleteAppHttpHandler extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.DELETE;
    }

    @Override
    public String getPath() {
        return "/jsdjjed/delete/app";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        res.setContentType("application/json; charset=utf-8");
        String repBody = IOUtils.inputStream2String(req.getInputStream(), "UTF-8");
        if (StringKit.isEmpty(repBody)) {
            WebUtils.printAsJSON(res, Utils.getFailuresResultJson("请求内容为空"));
            return;
        }

        JSONObject removeJson = new JSONObject(repBody);
        JSONArray idJsons = removeJson.getJSONArray("removeUserIds");
        if ((idJsons == null) || (idJsons.size() <= 0)) {
            WebUtils.printAsJSON(res, Utils.getSuccessResultJson());
            return;
        }
        String id;
        int size = idJsons.size();
        for (int i = 0, max = size - 1; i <= max; i++) {
            id = idJsons.getString(i);
            AppConfigData.deleteAppConfigDataWithId(id);
        }
        String resultContent = "{\"data\":{\"count\":" + size + "},\"stauts\":\"success\"}";
        WebUtils.printAsString(res, resultContent);
    }


}
