package com.fr.plugin.third.party.jsdjjed.http.app;

import com.fanruan.api.util.StringKit;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.general.IOUtils;
import com.fr.json.JSONObject;
import com.fr.plugin.third.party.jsdjjed.Utils;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigData;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigEntity;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class EditAppHttpHandler extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.PUT;
    }

    @Override
    public String getPath() {
        return "/jsdjjed/edit/app";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        res.setContentType("application/json; charset=utf-8");
        String repBody = IOUtils.inputStream2String(req.getInputStream(), "UTF-8");
        if (StringKit.isEmpty(repBody)) {
            WebUtils.printAsJSON(res, Utils.getFailuresResultJson("请求内容为空"));
            return;
        }
        JSONObject reqJson = new JSONObject(repBody);
        AppConfigEntity appConfigEntity = reqJson.mapTo(AppConfigEntity.class);
        if (AppConfigData.isAppConfigDataExistsWithConfigId(appConfigEntity.getConfigId(), appConfigEntity.getId())) {
            WebUtils.printAsJSON(res, Utils.getFailuresResultJson("应用唯一标识已存在"));
            return;
        }

        AppConfigEntity entity = AppConfigData.queryAppConfigDataWithConfigIdAndOnlyOne(appConfigEntity.getConfigId());
        if (entity == null) {
            WebUtils.printAsJSON(res, Utils.getFailuresResultJson("应用唯一标识不存在"));
            return;
        }
        appConfigEntity.setLogin(entity.getLogin());
        AppConfigData.updateAppConfigData(appConfigEntity);
        WebUtils.printAsJSON(res, Utils.getSuccessResultJson());
    }


}
