package com.fr.plugin.third.party.jsdjjed.http.app;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.third.party.jsdjjed.Utils;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigData;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigEntity;
import com.fr.plugin.third.party.jsdjjed.config.AppDataConfig;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 *
 */
public class QueryAppConfigHttpHandler extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/jsdjjed/query/config/app";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        res.setContentType("application/json; charset=utf-8");
        JSONObject dataJson = getConfigJsonData();
        WebUtils.printAsJSON(res, dataJson);
    }

    private JSONObject getConfigJsonData() {
        JSONObject dataJson = new JSONObject();
        dataJson.put("frUrl", AppDataConfig.getInstance().getFrUrl());
        dataJson.put("accessTokenUrl", AppDataConfig.getInstance().getAccessTokenUrl());
        dataJson.put("codeUserUrl", AppDataConfig.getInstance().getCodeUserUrl());
        dataJson.put("chatGroupsUrl", AppDataConfig.getInstance().getChatGroupsUrl());
        dataJson.put("usersUrl", AppDataConfig.getInstance().getUsersUrl());
        dataJson.put("sendMessageUrl", AppDataConfig.getInstance().getSendMessageUrl());
        dataJson.put("sendBatchMessageUrl", AppDataConfig.getInstance().getSendBatchMessageUrl());
        dataJson.put("uploadImageUrl", AppDataConfig.getInstance().getUploadImageUrl());
        dataJson.put("uploadFileUrl", AppDataConfig.getInstance().getUploadFileUrl());
        dataJson.put("authorizeUrl", AppDataConfig.getInstance().getAuthorizeUrl());

        dataJson.put("accessTokenUrlEscbOption", AppDataConfig.getInstance().isAccessTokenUrlEscbOption());
        dataJson.put("codeUserUrlEscbOption", AppDataConfig.getInstance().isCodeUserUrlEscbOption());
        dataJson.put("chatGroupsUrlEscbOption", AppDataConfig.getInstance().isChatGroupsUrlEscbOption());
        dataJson.put("usersUrlEscbOption", AppDataConfig.getInstance().isUsersUrlEscbOption());
        dataJson.put("sendMessageUrlEscbOption", AppDataConfig.getInstance().isSendMessageUrlEscbOption());
        dataJson.put("sendBatchMessageUrlEscbOption", AppDataConfig.getInstance().isSendBatchMessageUrlEscbOption());
        dataJson.put("uploadImageUrlEscbOption", AppDataConfig.getInstance().isUploadImageUrlEscbOption());
        dataJson.put("uploadFileUrlEscbOption", AppDataConfig.getInstance().isUploadFileUrlEscbOption());
        dataJson.put("authorizeUrlEscbOption", AppDataConfig.getInstance().isAuthorizeUrlEscbOption());
        dataJson.put("accessTokenUrlEscbCode", AppDataConfig.getInstance().getAccessTokenUrlEscbCode());
        dataJson.put("codeUserUrlEscbCode", AppDataConfig.getInstance().getCodeUserUrlEscbCode());
        dataJson.put("chatGroupsUrlEscbCode", AppDataConfig.getInstance().getChatGroupsUrlEscbCode());
        dataJson.put("usersUrlEscbCode", AppDataConfig.getInstance().getUsersUrlEscbCode());
        dataJson.put("sendMessageUrlEscbCode", AppDataConfig.getInstance().getSendMessageUrlEscbCode());
        dataJson.put("sendBatchMessageUrlEscbCode", AppDataConfig.getInstance().getSendBatchMessageUrlEscbCode());
        dataJson.put("uploadImageUrlEscbCode", AppDataConfig.getInstance().getUploadImageUrlEscbCode());
        dataJson.put("uploadFileUrlEscbCode", AppDataConfig.getInstance().getUploadFileUrlEscbCode());
        dataJson.put("authorizeUrlEscbCode", AppDataConfig.getInstance().getAuthorizeUrlEscbCode());
        dataJson.put("accessTokenUrlEscbVersion", AppDataConfig.getInstance().getAccessTokenUrlEscbVersion());
        dataJson.put("codeUserUrlEscbVersion", AppDataConfig.getInstance().getCodeUserUrlEscbVersion());
        dataJson.put("chatGroupsUrlEscbVersion", AppDataConfig.getInstance().getChatGroupsUrlEscbVersion());
        dataJson.put("usersUrlEscbVersion", AppDataConfig.getInstance().getUsersUrlEscbVersion());
        dataJson.put("sendMessageUrlEscbVersion", AppDataConfig.getInstance().getSendMessageUrlEscbVersion());
        dataJson.put("sendBatchMessageUrlEscbVersion", AppDataConfig.getInstance().getSendBatchMessageUrlEscbVersion());
        dataJson.put("uploadImageUrlEscbVersion", AppDataConfig.getInstance().getUploadImageUrlEscbVersion());
        dataJson.put("uploadFileUrlEscbVersion", AppDataConfig.getInstance().getUploadFileUrlEscbVersion());
        dataJson.put("authorizeUrlEscbVersion", AppDataConfig.getInstance().getAuthorizeUrlEscbVersion());
        dataJson.put("escbUrl", AppDataConfig.getInstance().getEscbUrl());
        dataJson.put("escbAppCode", AppDataConfig.getInstance().getEscbAppCode());
        dataJson.put("escbAppToken", AppDataConfig.getInstance().getEscbAppToken());
        dataJson.put("escbOrgCode", AppDataConfig.getInstance().getEscbOrgCode());
        dataJson.put("escbSysCode", AppDataConfig.getInstance().getEscbSysCode());

        dataJson.put("page", 1);
        JSONObject json = Utils.getSuccessResultJson();
        json.put("data", dataJson);
        return json;
    }


}
