package com.fr.plugin.third.party.jsdjjed.http.app;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigData;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigEntity;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 *
 */
public class QueryAppHttpHandler extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/jsdjjed/query/app";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        res.setContentType("application/json; charset=utf-8");
        List<AppConfigEntity> entities = AppConfigData.queryAllAppConfigData();
        JSONObject dataJson = createJsonData(entities);
        WebUtils.printAsJSON(res, dataJson);
    }

    private JSONObject createJsonData(List<AppConfigEntity> entities) {
        int total = entities.size();
        JSONArray itemsJsons = new JSONArray();
        AppConfigEntity entity;
        JSONObject itemsJson;
        for (int i = 0, max = total - 1; i <= max; i++) {
            entity = entities.get(i);
            itemsJson = JSONObject.mapFrom(entity);
            if (entity.getLogin() == 1) {
                itemsJson.put("enable", true);
            } else {
                itemsJson.put("enable", false);
            }
            itemsJson.put("show", entity.getConfigId() + "_" + entity.getNotes());
            itemsJsons.add(itemsJson);
        }

        JSONObject dataJson = new JSONObject();
        dataJson.put("total", total);
        dataJson.put("page", 1);
        dataJson.put("items", itemsJsons);

        JSONObject json = new JSONObject();
        json.put("data", dataJson);
        return json;
    }


}
