package com.fr.plugin.third.party.jsdjjed.http.app;

import com.fanruan.api.util.StringKit;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.general.IOUtils;
import com.fr.json.JSONObject;
import com.fr.plugin.third.party.jsdjjed.Utils;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigData;
import com.fr.plugin.third.party.jsdjjed.app.config.AppConfigEntity;
import com.fr.plugin.third.party.jsdjjed.config.AppDataConfig;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class SaveAppConfigHttpHandler extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.PUT;
    }

    @Override
    public String getPath() {
        return "/jsdjjed/save/config/app";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        res.setContentType("application/json; charset=utf-8");
        String repBody = IOUtils.inputStream2String(req.getInputStream(), "UTF-8");
        if (StringKit.isEmpty(repBody)) {
            WebUtils.printAsJSON(res, Utils.getFailuresResultJson("请求内容为空"));
            return;
        }
        JSONObject reqJson = new JSONObject(repBody);
        String frUrl = reqJson.getString("frUrl", "");
        String accessTokenUrl = reqJson.getString("accessTokenUrl", "");
        String codeUserUrl = reqJson.getString("codeUserUrl", "");
        String chatGroupsUrl = reqJson.getString("chatGroupsUrl", "");
        String usersUrl = reqJson.getString("usersUrl", "");
        String sendMessageUrl = reqJson.getString("sendMessageUrl", "");
        String sendBatchMessageUrl = reqJson.getString("sendBatchMessageUrl", "");
        String uploadImageUrl = reqJson.getString("uploadImageUrl", "");
        String uploadFileUrl = reqJson.getString("uploadFileUrl", "");
        String authorizeUrl = reqJson.getString("authorizeUrl", "");

        AppDataConfig.getInstance().setFrUrl(frUrl);
        AppDataConfig.getInstance().setAccessTokenUrl(accessTokenUrl);
        AppDataConfig.getInstance().setCodeUserUrl(codeUserUrl);
        AppDataConfig.getInstance().setChatGroupsUrl(chatGroupsUrl);
        AppDataConfig.getInstance().setUsersUrl(usersUrl);
        AppDataConfig.getInstance().setSendMessageUrl(sendMessageUrl);
        AppDataConfig.getInstance().setSendBatchMessageUrl(sendBatchMessageUrl);
        AppDataConfig.getInstance().setUploadImageUrl(uploadImageUrl);
        AppDataConfig.getInstance().setUploadFileUrl(uploadFileUrl);
        AppDataConfig.getInstance().setAuthorizeUrl(authorizeUrl);

        AppDataConfig.getInstance().setAccessTokenUrlEscbOption(reqJson.getBoolean("accessTokenUrlEscbOption"));
        AppDataConfig.getInstance().setCodeUserUrlEscbOption(reqJson.getBoolean("codeUserUrlEscbOption"));
        AppDataConfig.getInstance().setChatGroupsUrlEscbOption(reqJson.getBoolean("chatGroupsUrlEscbOption"));
        AppDataConfig.getInstance().setUsersUrlEscbOption(reqJson.getBoolean("usersUrlEscbOption"));
        AppDataConfig.getInstance().setSendMessageUrlEscbOption(reqJson.getBoolean("sendMessageUrlEscbOption"));
        AppDataConfig.getInstance().setSendBatchMessageUrlEscbOption(reqJson.getBoolean("sendBatchMessageUrlEscbOption"));
        AppDataConfig.getInstance().setUploadImageUrlEscbOption(reqJson.getBoolean("uploadImageUrlEscbOption"));
        AppDataConfig.getInstance().setUploadFileUrlEscbOption(reqJson.getBoolean("uploadFileUrlEscbOption"));
        AppDataConfig.getInstance().setAuthorizeUrlEscbOption(reqJson.getBoolean("authorizeUrlEscbOption"));


        AppDataConfig.getInstance().setAccessTokenUrlEscbCode(reqJson.getString("accessTokenUrlEscbCode",""));
        AppDataConfig.getInstance().setCodeUserUrlEscbCode(reqJson.getString("codeUserUrlEscbCode",""));
        AppDataConfig.getInstance().setChatGroupsUrlEscbCode(reqJson.getString("chatGroupsUrlEscbCode",""));
        AppDataConfig.getInstance().setUsersUrlEscbCode(reqJson.getString("usersUrlEscbCode",""));
        AppDataConfig.getInstance().setSendMessageUrlEscbCode(reqJson.getString("sendMessageUrlEscbCode",""));
        AppDataConfig.getInstance().setSendBatchMessageUrlEscbCode(reqJson.getString("sendBatchMessageUrlEscbCode",""));
        AppDataConfig.getInstance().setUploadImageUrlEscbCode(reqJson.getString("uploadImageUrlEscbCode",""));
        AppDataConfig.getInstance().setUploadFileUrlEscbCode(reqJson.getString("uploadFileUrlEscbCode",""));
        AppDataConfig.getInstance().setAuthorizeUrlEscbCode(reqJson.getString("authorizeUrlEscbCode",""));
        AppDataConfig.getInstance().setAccessTokenUrlEscbVersion(reqJson.getString("accessTokenUrlEscbVersion",""));
        AppDataConfig.getInstance().setCodeUserUrlEscbVersion(reqJson.getString("codeUserUrlEscbVersion",""));
        AppDataConfig.getInstance().setChatGroupsUrlEscbVersion(reqJson.getString("chatGroupsUrlEscbVersion",""));
        AppDataConfig.getInstance().setUsersUrlEscbVersion(reqJson.getString("usersUrlEscbVersion",""));
        AppDataConfig.getInstance().setSendMessageUrlEscbVersion(reqJson.getString("sendMessageUrlEscbVersion",""));
        AppDataConfig.getInstance().setSendBatchMessageUrlEscbVersion(reqJson.getString("sendBatchMessageUrlEscbVersion",""));
        AppDataConfig.getInstance().setUploadImageUrlEscbVersion(reqJson.getString("uploadImageUrlEscbVersion",""));
        AppDataConfig.getInstance().setUploadFileUrlEscbVersion(reqJson.getString("uploadFileUrlEscbVersion",""));
        AppDataConfig.getInstance().setAuthorizeUrlEscbVersion(reqJson.getString("authorizeUrlEscbVersion",""));
        AppDataConfig.getInstance().setEscbUrl(reqJson.getString("escbUrl",""));
        AppDataConfig.getInstance().setEscbAppCode(reqJson.getString("escbAppCode",""));
        AppDataConfig.getInstance().setEscbAppToken(reqJson.getString("escbAppToken",""));
        AppDataConfig.getInstance().setEscbOrgCode(reqJson.getString("escbOrgCode",""));
        AppDataConfig.getInstance().setEscbSysCode(reqJson.getString("escbSysCode",""));

        WebUtils.printAsJSON(res, Utils.getSuccessResultJson());
    }


}
