package com.fr.plugin.third.party.jsdjjed.schedule.bean;


import com.fr.plugin.third.party.jsdjjed.schedule.entity.AppMessagePushEntity;
import com.fr.schedule.base.bean.output.BaseOutputAction;
import com.fr.schedule.base.entity.AbstractScheduleEntity;
import com.fr.schedule.base.type.RunType;
import com.fr.third.fasterxml.jackson.annotation.JsonSubTypes;


@JsonSubTypes.Type(value = OutputAppMessagePush.class, name = "OutputAppMessagePush")
public class OutputAppMessagePush extends BaseOutputAction {
    private int terminal = 64;

    private String subject;

    private String content;

    /**
     * 客户端通知 消息类型</br>
     * 1:链接消息;2:图文消息;3:文件消息
     */
    private int type;

    private String configId;

    private String chatGroupId;

    private String feishuMsgType;

    private String feishuSendType;


    /**
     * 客户端通知 定时结果附件
     */
    private int mediaId;

    private int runType = RunType.CLIENT_NOTIFICATION.getValue();

    //是否受不同用户生成不同附件影响
    @Override
    public boolean willExecuteByUser() {
        return false;
    }

    //推送类型
    @Override
    public RunType runType() {
        return RunType.CLIENT_NOTIFICATION;
    }

    @Override
    public Class<? extends AbstractScheduleEntity> outputActionEntityClass() {
        return AppMessagePushEntity.class;
    }

    @Override
    public AbstractScheduleEntity createOutputActionEntity() {
        AppMessagePushEntity entity = new AppMessagePushEntity();
        entity.setId(this.getId());
        entity.setContent(this.getContent());
        entity.setSubject(this.getSubject());
        entity.setTerminal(this.getTerminal());
        entity.setType(this.getType());
        entity.setConfigId(this.getConfigId());
        entity.setChatGroupId(this.getChatGroupId());
        entity.setMediaId(this.getMediaId());
        entity.setFeishuMsgType(this.getFeishuMsgType());
        entity.setFeishuSendType(this.getFeishuSendType());
        return entity;
    }


    public int getTerminal() {
        return terminal;
    }

    public void setTerminal(int terminal) {
        this.terminal = terminal;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public int getRunType() {
        return runType;
    }

    public void setRunType(int runType) {
        this.runType = runType;
    }

    public String getConfigId() {
        return configId;
    }

    public void setConfigId(String configId) {
        this.configId = configId;
    }

    public String getChatGroupId() {
        return chatGroupId;
    }

    public void setChatGroupId(String chatGroupId) {
        this.chatGroupId = chatGroupId;
    }

    public int getMediaId() {
        return mediaId;
    }

    public void setMediaId(int mediaId) {
        this.mediaId = mediaId;
    }

    public String getFeishuMsgType() {
        return feishuMsgType;
    }

    public void setFeishuMsgType(String feishuMsgType) {
        this.feishuMsgType = feishuMsgType;
    }

    public String getFeishuSendType() {
        return feishuSendType;
    }

    public void setFeishuSendType(String feishuSendType) {
        this.feishuSendType = feishuSendType;
    }
}
