package com.fr.plugin.third.party.jsdjjed.schedule.components;

import com.fr.web.struct.Component;
import com.fr.web.struct.Filter;
import com.fr.web.struct.browser.RequestClient;
import com.fr.web.struct.category.ScriptPath;
import com.fr.web.struct.category.StylePath;


public class FileDef extends Component {

    public static final FileDef KEY = new FileDef();
    private FileDef(){}

    /**
     * 返回需要引入的JS脚本路径
     * @param client 请求客户端描述
     * @return JS脚本路径
     */
    @Override
    public ScriptPath script(RequestClient client) {
        return ScriptPath.build("com/fr/plugin/third/party/jsdjjed/message.js");
    }

    /**
     * 返回需要引入的CSS样式路径
     * @param client 请求客户端描述
     * @return CSS样式路径
     */
    @Override
    public StylePath style(RequestClient client) {
//         //如果不需要就直接返回 StylePath.EMPTY;
//        return StylePath.build("com/fr/plugin/publiclinksecurty/componet/demo.css");
         return StylePath.EMPTY;
    }


    @Override
    public Filter filter() {
        return new Filter(){
            public boolean accept() {
                //任何情况下我们都在平台组件加载时加载我们的组件
                return true;
            }
        };
    }
}
